"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _react = require("react");

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _get = require("../../../services/get");

var _pusherCodeby = require("../../../configs/pusherCodeby");

var _PeopleCalling = _interopRequireDefault(require("../Components/PeopleCalling"));

var _graphqlComment = require("../../ChatAntd/Graphql/graphqlComment");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const unflatten = require('flat').unflatten;

const VideoChatPage = () => {
  const params = unflatten((0, _get.getURLParams)());
  const {
    unique,
    app_id,
    people,
    other,
    join
  } = params;
  const roomId = "".concat(app_id, "-").concat(unique.special_id);
  const [iComment, setIComment] = (0, _react.useState)({});
  const [show, setShow] = (0, _react.useState)(false);
  (0, _react.useEffect)(() => {
    setTimeout(() => {
      _pusherCodeby.pusherCodeby.room(roomId).onAny((event, data) => {
        console.log('event, data', event, data);

        switch (event) {
          case 'video_chat_join':
            setShow(true);
            break;

          case 'video_chat_left':
            window.close();
            break;
        }
      });
    }, 100);
  });
  (0, _react.useEffect)(() => {
    if (join) {
      setShow(true);

      _pusherCodeby.pusherCodeby.room(roomId).emit('video_chat_join', params);
    } else {
      _pusherCodeby.pusherCodeby.room(roomId).emit('video_chat', _objectSpread(_objectSpread({}, params), {}, {
        url: window.location.href
      }));
    }
  });
  (0, _react.useEffect)(() => {
    if (iComment.data) {
      _pusherCodeby.pusherCodeby.room(roomId).emit('chat', iComment);
    }
  }, [iComment]);

  const cancel = async () => {
    setIComment({
      isLoading: true
    });
    const res = await (0, _graphqlComment.upsertComment)({
      unique,
      people,
      app_id,
      content: "Video chat cancel",
      type: "video_chat"
    });
    setIComment({
      isLoading: true,
      data: res.data.upsert_comment
    });
    setTimeout(() => {
      window.close();
    }, 100);
  };

  let api;
  (0, _react.useEffect)(() => {
    if (!show) return;

    if (!window.JitsiMeetExternalAPI) {
      alert("JitsiMeetExternalAPI not loaded");
      return;
    }

    const options = {
      roomName: roomId,
      width: "100%",
      height: window.innerHeight,
      parentNode: document.querySelector("#jitsi-iframe"),
      interfaceConfigOverwrite: {},
      configOverwrite: {
        prejoinPageEnabled: false,
        disableDeepLinking: true
      },
      userInfo: {
        displayName: people.name,
        avatarUrl: people.avatar
      }
    };
    api = new window.JitsiMeetExternalAPI("meet.jit.si", options);
    api.addEventListeners({
      async videoConferenceLeft() {
        _pusherCodeby.pusherCodeby.room(roomId).emit('video_chat_left', params);

        const res = await (0, _graphqlComment.upsertComment)({
          unique,
          people,
          app_id,
          content: "Video chat left",
          type: "video_chat"
        });
        setTimeout(() => {
          window.close();
        }, 100);
      }

    });
  }, [show]);
  return /*#__PURE__*/React.createElement("main", {
    className: "bg-indigo-500 h-screen w-screen relative"
  }, show && /*#__PURE__*/React.createElement("div", {
    id: "jitsi-iframe"
  }), !show && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_PeopleCalling.default, {
    people: other
  }), /*#__PURE__*/React.createElement("div", {
    className: "absolute absolute-x bottom-0 mb-10"
  }, /*#__PURE__*/React.createElement(_antd.Space, {
    size: "large"
  }, /*#__PURE__*/React.createElement(_antd.Button, {
    size: "large",
    icon: /*#__PURE__*/React.createElement(_icons.CloseOutlined, null),
    onClick: () => cancel(),
    loading: iComment.isLoading
  })))));
};

var _default = VideoChatPage;
exports.default = _default;